package org.processmining.ptconversions.plugins;

import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.graphbased.directed.epc.ConfigurableEPC;
import org.processmining.processtree.ProcessTree;
import org.processmining.ptconversions.epc.ProcessTree2EPC;


@Plugin(
	name = "Convert Process Tree to EPC", 
	parameterLabels = { "Process Tree" }, 
	returnLabels = { "EPC" }, 
	returnTypes = { ConfigurableEPC.class }, 
	userAccessible = true)
public class PluginEPC {
	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "D.M.M. Schunselaar", email = "d.m.m.schunselaar@tue.nl", uiLabel = "Convert ProcessTree to EPC (unfold tree)")
	@PluginVariant(variantLabel = "Select Tree to convert", requiredParameterLabels = { 0 })
	public ConfigurableEPC convertUnfold(PluginContext context, ProcessTree tree){
		ProcessTree2EPC converter = new ProcessTree2EPC();
		return converter.convert(context, tree, true);
	}
	
	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "D.M.M. Schunselaar", email = "d.m.m.schunselaar@tue.nl", uiLabel = "Convert ProcessTree to EPC (do not unfold tree)")
	@PluginVariant(variantLabel = "Select Tree to convert", requiredParameterLabels = { 0 })
	public ConfigurableEPC convertNoUnfold(PluginContext context, ProcessTree tree){
		ProcessTree2EPC converter = new ProcessTree2EPC();
		return converter.convert(context, tree, false);
	}
}

